/******************************

Filename: init_setting.c

******************************/


#include "iodefine.h"
#include <machine.h>

#ifdef __cplusplus
extern "C" {
#endif
/******************************/

#include "iodefine.h"
#include "common.h"

/***************************************************/
/**
  * H/WZbgAbvs܂B
  *
  * NbN̎gݒ肵܂
  * CMTiRyA}b`^C}j܂
  * MTUi}`^C}[jbgj܂
  * IO|[g܂
  * @param 			Ȃ
  * @return @@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void init_setting( void )
{
    HWS_Ini_Clock();  // NbNݒ
    HWS_Ini_CMT();    // CMTݒ
    HWS_Ini_MTU();    // MTUݒ
    HWS_Ini_Port();   // |[gݒ
}
/**
  * LED,XCb`́AuU[o͂I/Oݒs܂B
  *
  * o͂̏ꍇ͂܂0o͂ݒs
  * ̌o͕w肷
  * 
  * @param 			Ȃ
  * @return @@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void HWS_Ini_Port( void )
{
    // o̓f[^ݒ(DR)
    //   0 : 0o
    //   1 : 1o
    PORTB.DR.BYTE   = 0x00; // LED@	
    PORTD.DR.BYTE   = 0x00; // LED@	
	PORTE.DR.BYTE   = 0x00; // LED@	

    // o͐ݒ(DDR)("DR"ŏo)("PORT"œ)
    //   0 : 
    //   1 : o

    PORTB.DDR.BYTE   = 0xFF; // LED@	o͕
    PORTD.DDR.BYTE   = 0xFF; // LED@	o͕
	PORTE.DDR.BYTE   = 0xFF; // LED@	o͕

    PORTC.DDR.BYTE   = 0x00; // SW1-8	͕
    PORT5.DDR.BYTE	 = 0x20; // SW9-13	͕(P55N.Cio̓|[gj)


	PORTA.DR.BIT.B0  = 0;	 // uU[@0o 
	PORTA.DDR.BIT.B0 = 1;	 // uU[@o͕ 
	
	return;	
}
/**
  * NbN̐ݒs܂B
  * ICLK,PCLK,BCLK̕w肵܂
  * TuNbN͎gpȂ߁A~Ă܂
  * 
  * @param 			Ȃ
  * @return @@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void HWS_Ini_Clock( void )
{
	SYSTEM.SCKCR.LONG= 0x00820100; 
	while( SYSTEM.SCKCR.LONG != 0x00820100 ); // ҂
        // ݒ肷NbN̎
        // @ӃW[NbN(PCLK)
        // AVXeNbN(ICLK)
        // BOoXNbN(BCLK)

        // BIT0-7 --- \rbg("0"ƋLq)

        // BIT8-11 --- ӃW[NbNa(PCLKB)Irbg
        //   0 0 0 0 : 8  {
        //   0 0 0 1 : 4  {( EXTEL(12MHz)*4 = 48MHz )
        //   0 0 1 0 : 2  { 
        //   0 0 1 1 : 1  {

        // BIT12-15 --- \rbg("0"ƋLq)

        // BIT16-19 --- OoXNbN(BCLK)Irbg
        //   0 0 0 0 : 8  {
        //   0 0 0 1 : 4  {
        //   0 0 1 0 : 2  {( EXTEL(12MHz)*2 = 24MHz )
        //   0 0 1 1 : 1  {

        // BIT20-21 --- \rbg("0"ƋLq)

        // BIT22 --- SDCLK[qo͐rbg
        //   0 : SDCLK[qo͓ 
        //   1 : SDCLK[qo͒~

        // BIT23 --- BCLK[qo͐rbg
        //   0 : BCLK[qo͓
        //   1 : BCLK[qo͒~ 

        // BIT24-27 ---  VXeNbN(ICLK)Irbg
        //   0 0 0 0 : 8  {( EXTEL(12MHz)*8 = 96MHz )
        //   0 0 0 1 : 4  {
        //   0 0 1 0 : 2  {
        //   0 0 1 1 : 1  {


        // BIT28-31 ---  \rbg("0"ƋLq)
		
		SYSTEM.OSTDCR.BIT.OSTDE = 1;		//U~o@\Lɂ
		
		while(SYSTEM.OSTDCR.BIT.OSTDF !=0)	//CNbNU킪퓮삵Ă邱ƂmF
		{;}
		
		//
		//{͂ŃNbN҂s܂
		//RX621̓n[hEFAdlɂ
		//ÑNbN҂͕svł
		//
		
    // TuNbNU~
    SYSTEM.SUBOSCCR.BYTE= 0x01;
    while( SYSTEM.SUBOSCCR.BYTE != 0x01 ); //  ҂
        // BIT0 --- TuNbNU~rbg
        //   0 : TuNbNU퓮
        //   1 : TuNbNU~ 

        // BIT1-7 --- \rbg("0"ƋLq)

		//
		//{͂ŃNbN҂s܂
		//TuNbNgpȂ߃NbN҂͕svł
		//
		
	return;
}
/**
  * CMTiRyA}b`^C}j̐ݒs܂
  * PCLK̕w肵܂
  * JEgl̐ݒs܂
  * 
  * @param 			Ȃ
  * @return @@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void HWS_Ini_CMT( void )
{
    // W[XgbvԂ
    MSTP_CMT0 = 0; // CMT0
    MSTP_CMT1 = 0; // CMT1
    MSTP_CMT2 = 0; // CMT2
    MSTP_CMT3 = 0; // CMT3

    // CMT0ACMT1̒~
    CMT.CMSTR0.WORD = 0x0000;
        // BIT0 --- CMT0.CMCNTJE^̃JEgJn/~
        //  0 : CMT0.CMCNTJE^̃JEg~
        //  1 : CMT0.CMCNTJE^̃JEgJn

        // BIT1 --- CMT1.CMCNTJE^̃JEgJn/~
        //  0 : CMT1.CMCNTJE^̃JEg~
        //  1 : CMT1.CMCNTJE^̃JEgJn

        // BIT2-15 --- \rbg("0"ƋLq)

    // CMT2ACMT3̒~
    CMT.CMSTR1.WORD = 0x0000;
        // BIT0 --- CMT2.CMCNTJE^̃JEgJn/~
        //  0 : CMT2.CMCNTJE^̃JEg~
        //  1 : CMT2.CMCNTJE^̃JEgJn

        // BIT1 --- CMT3.CMCNTJE^̃JEgJn/~
        //  0 : CMT3.CMCNTJE^̃JEg~
        //  1 : CMT3.CMCNTJE^̃JEgJn

        //BIT2-15 --- \rbg("0"ƋLq)

    // CMTn(n:0-3)̃RyA}b`荞݋ANbNݒ
    CMT0.CMCR.WORD = 0x00C0;    // 8I
    CMT1.CMCR.WORD = 0x00C0;    // 8I
	CMT2.CMCR.WORD = 0x00C0;    // 8I
	CMT3.CMCR.WORD = 0x00C0;    // 8I
        // BIT0-1 --- NbNIrbg
        //   0 0 : PCLK / 8   ( 48/8 = 6MHz )
        //   0 1 : PCLK / 32
        //   1 0 : PCLK / 128
        //   1 1 : PCLK / 512

        // BIT2-5 --- \rbg("0"ƋLq)

        // BIT6 --- RyA}b`荞݋rbg
        //   0 : RyA}b`荞(CMln)֎~
        //   1 : RyA}b`荞(CMln) 

        // BIT7 ---  \rbg("1"ƋLq)         LqӁ

        // BIT8-15 ---  \rbg("0"ƋLq)

    // CMTn(n:0-3)^C}JE^̏
    CMT0.CMCNT = 0; // CMT0 JE^
    CMT1.CMCNT = 0; // CMT1 JE^
    CMT2.CMCNT = 0; // CMT2 JE^
    CMT3.CMCNT = 0; // CMT3 JE^

    // 荞ݎݒ
    // ^C~Oݒ@
    //   @ CMCRWX^ݒŁAӃW[NbNB𕪎
    //        ӃW[NbNB  ( 8 or 32 or 128 or 518 )
    //   A CMCORWX^ݒŁǍvZʂ^C~O(b)
    //        ( 0`65536 )  @̌vZ
    //
    // vZၦ ... 1ms̃^C}(ӃW[NbNB48MHz)
    //   @ CMCRWX^ݒŁA8I
    //      48M  8() = 6M
    //   A CMCORWX^ݒŁA60000ݒ
    //      ( 6000 )  6M = 0.001s = 1 ms
    CMT0.CMCOR = 6000;	// 1msƂɊ荞ݎs
    CMT1.CMCOR = 60;	// 10s
	CMT2.CMCOR = 6000;
	CMT3.CMCOR = 6000;

    // 荞ݗv
    IEN( CMT0, CMI0 ) = 1; // CMT0
    IEN( CMT1, CMI1 ) = 1; // CMT1
    IEN( CMT2, CMI2 ) = 1; // CMT2
    IEN( CMT3, CMI3 ) = 1; // CMT3

    // 荞ݗD惌xݒ
    IPR( CMT0, CMI0 ) = 1; // CMT0
    IPR( CMT1, CMI1 ) = 1; // CMT1
    IPR( CMT2, CMI2 ) = 1; // CMT2
    IPR( CMT3, CMI3 ) = 1; // CMT3

    //  RyA}b`荞݋
    CMT0.CMCR.BIT.CMIE = 1; // CMT0
    CMT1.CMCR.BIT.CMIE = 1; // CMT1
    CMT2.CMCR.BIT.CMIE = 1; // CMT2
    CMT3.CMCR.BIT.CMIE = 1; // CMT3
	
	
	CMT.CMSTR0.WORD = 0x0001;	//CMT0JEgJn
	return;
}
/**
  * MTUi}`t@NV^C}pXjbgj̐ݒs܂
  * PCLK̕w肵܂
  * [hݒs܂
  * RyA}b`l̐ݒs܂
  * 
  * @param 			Ȃ
  * @return @@@@Ȃ
  * @author Yoshinobu Ito
  * @version 1
  */
void HWS_Ini_MTU( void )
{

	SYSTEM.MSTPCRA.BIT.MSTPA8 = 0;	//MTU6`11̃W[Xgbv
	
	MTUB.TSTR.BIT.CST0 = 0;			// TMDR ֓샂[hݒ肷ׁATCNT~
    MTU6.TMDR.BYTE    = 0x02;       // PWM[h1ɐݒ
    MTU6.TCR.BYTE     = 0x23;       // ^C}vXP[64 
	MTU6.TIORH.BYTE   = 0x21;		// MTIOC6A[q̋@\TGRAoLowARyA}b`Higho	   
	MTU6.TCNT = 0;                  // MTU6̃JE^Zbg
    MTU6.TGRA = 27272;              // JE^BOFFo
    MTU6.TGRB = MTU6.TGRA / 2;      // JE^ɂON
	
	return;  
}